local Tutorial = foundation.createMod();

---------------------
-- Asset Processor --
---------------------
Tutorial:registerAssetProcessor("models/cube.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})

---------------
-- Asset IDs --
---------------
Tutorial:registerAssetId("models/cube.fbx/Prefab/Cube_Part", "PREFAB_CUBE_PART")
Tutorial:registerAssetId("models/cube.fbx/Prefab/Cube_Large_Part", "PREFAB_CUBE_LARGE_PART")
Tutorial:registerAssetId("models/cube.fbx/Prefab/Root_Part", "PREFAB_ROOT_PART")
Tutorial:registerAssetId("models/cube.fbx/Prefab/Tiling_Part", "PREFAB_TILING_PART")

-----------------------
-- Monument Building --
-----------------------
Tutorial:register({
    DataType = "BUILDING",
    Id = "CUBE_MONUMENT",
    Name = "CUBE_MONUMENT_NAME",
    Description = "CUBE_MONUMENT_DESC",
    BuildingType = "DECORATION",
    AssetCoreBuildingPart = "BUILDING_PART_MONUMENT_POLE",
    BuildingPartSetList = {
		{
			Name = "CUBE_LIST_NAME",
	        BuildingPartList = {
                "CUBE_PART",
                "CUBE_LARGE_PART"
			}
        }
    }
})

--------------------
-- Building Parts --
--------------------
Tutorial:register({
	DataType = "BUILDING_PART",
	Id = "CUBE_PART",
	Name = "CUBE_NAME",
	Description = "CUBE_DESC",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_SCALER",
		CoreObjectPrefab = "PREFAB_ROOT_PART",
		EndPart = "CUBE",
		FillerList = {
			"TILING"
    	},
		BasementFillerList = {
			"TILING"
       	},
		MinimumScale = 2,
		IsVertical = true
	}
})
Tutorial:register({
	DataType = "BUILDING_PART",
	Id = "CUBE",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_CUBE_PART"
	}
})

Tutorial:register({
	DataType = "BUILDING_PART",
	Id = "CUBE_LARGE_PART",
	Name = "CUBE_LARGE_NAME",
	Description = "CUBE_LARGE_DESC",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_SCALER",
		CoreObjectPrefab = "PREFAB_ROOT_PART",
		EndPart = "CUBE_LARGE",
		FillerList = {
			"TILING"
    	},
		BasementFillerList = {
			"TILING"
       	},
		MinimumScale = 2,
		IsVertical = true
	}
})
Tutorial:register({
	DataType = "BUILDING_PART",
	Id = "CUBE_LARGE",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_CUBE_LARGE_PART"
	}
})

-------------------
-- Scaling Parts --
-------------------
Tutorial:register({
	DataType = "BUILDING_PART",
	Id = "TILING",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_TILING_PART"
	}
})